<?php
/*
This script requires the following mysql table:

CREATE TABLE esp32iot (
			`date` DATETIME NOT NULL,
			`ipaddress` VARCHAR(16) NOT NULL,
			`key` VARCHAR(16) PRIMARY KEY,
			`value` VARCHAR(32) NOT NULL
)

===
IMPORTANT NOTICE, please read:

This software is licensed under the terms of the GNU GENERAL PUBLIC LICENSE,
please read the enclosed file license.txt or http://www.gnu.org/licenses/licenses.html

The use of this software is at the risk of the user.
*/
define("secret", "rshe*i76"); // <-- change secret value here and inside sketch ESP_sensor.ino

//define here mysql site specific info:
define("mysql_host", "localhost");
define("mysql_user", "your user");
define("mysql_pwd", "your password");
define("mysql_db", "your mysql db");


if ($_SERVER['REQUEST_METHOD'] !== 'POST') {//this script shall be invoked with POST
	header("HTTP/1.1 405 Method Not Allowed");
	echo_error("invalid method, only POST is allowed");
	exit;
}

//json parameters
$data = json_decode(file_get_contents('php://input'));
//decode parameters, v = 1
$parameters = array();
foreach ($data as $key => $value) {
	if ($key == "v")
		$version = $value;
	else if ($key == "secret")
		$secret = $value;
	else $parameters[$key] = $value;
}

if (!isset($secret) || ($secret !== secret)) { 
	header("HTTP/1.1 403 Forbidden");
	echo_error("missing or invalid secret received");
	exit;
}

date_default_timezone_set("Europe/Rome");// added for PHP5 migration
mb_internal_encoding("UTF-8");

if (empty($version)) {
	header("HTTP/1.1 400 Bad Request");
	echo_error("Bad Request, version is missing");
	exit;
}
if (empty($key)||empty($value)) {
	header("HTTP/1.1 400 Bad Request");
	echo_error("Bad Request, data is missing");
	exit;
}

$link = connect_MySQL();
if ($link) {
	$_mydate = date("Y-m-d H:i:s",time());
	$ipaddress = getRemoteAddr();
	foreach ($parameters as $key => $value) {
		$query = "INSERT INTO esp32iot (`date`, `ipaddress`, `key`, `value`) VALUES ('$_mydate', '$ipaddress', '$key', '$value') ON DUPLICATE KEY UPDATE `date` = '$_mydate', `ipaddress` = '$ipaddress', `value` = '$value'";	
		mysqli_query($link, $query);
	}
	mysqli_close($link);
}



////////////
// getRemoteAddr() returns the real IP address
// in qualche caso la variabile $_SERVER['REMOTE_ADDR'] restituisce l'indirizzo di un intermediario IP (es: CloudFlare) invece dell'indirizzo utente 
function getRemoteAddr(){
	  if (!empty($_SERVER['HTTP_X_FORWARDED_FOR']))
		return $_SERVER['HTTP_X_FORWARDED_FOR'];
	  else
		return $_SERVER['REMOTE_ADDR'];
}


//////////////
function connect_MySQL() {
	if (empty($_SESSION['mysql_error'])) {
		$link = @mysqli_connect(mysql_host, mysql_user, mysql_pwd);
		if ($link) {
			mysqli_select_db($link, mysql_db);
			if (!mysqli_errno($link))
				return $link;
			else mysqli_close($link);
		} else $_SESSION['mysql_error'] = true;
	}
}

function echo_error($msg, $trigger = true) {
	echo $msg;
	if ($trigger)
		trigger_error($msg);
}


?>